#include "circ_list.h"

#include <stdlib.h>

element *list_create() {
    return NULL;
}

bool list_empty(element *head) {
    return head == NULL;
}

unsigned int list_count(element *head) {
    if (list_empty(head)) {
        return 0;
    }

    unsigned int count = 0;
    element *iterator = head;

    do {
        count += 1;
        iterator = iterator->next;
    } while (iterator != head);

    return count;
}

element *list_move(element *head) {
    if (list_empty(head)) {
        return NULL;
    }

    return head->next;
}

element *list_insert_after(element *head, int data) {
    element *new_element = (element *)malloc(sizeof(element));
    new_element->data = data;

    if (list_empty(head)) {
        new_element->next = new_element;
    } else {
        new_element->next = head->next;
        head->next = new_element;
    }

    return new_element;
}

element *list_insert_before(element *head, int data) {
    if (list_empty(head)) {
        return list_insert_after(head, data);
    }

    element *iterator = head;

    while (iterator->next != head) {
        iterator = iterator->next;
    }

    return list_insert_after(iterator, data);
}

element *list_search(element *head, int data) {
    if (list_empty(head)) {
        return NULL;
    }

    element *iterator = head;

    do {
        if (iterator->data == data) {
            return iterator;
        }

        iterator = iterator->next;
    } while (iterator != head);

    return NULL;
}

element *list_remove(element **head, int data) {
    element *el = list_search(*head, data);

    if (el == NULL) {
        return NULL;
    }

    element *iterator = *head;

    while (iterator->next != el) {
        iterator = iterator->next;
    }

    iterator->next = iterator->next->next;

    if (el == *head) {
        *head = iterator;
    }

    if (iterator == el) {
        *head = NULL;
    }

    return el;
}

void list_free(element **head) {
    if (list_empty(*head)) {
        return;
    }

    element *iterator = *head;

    do {
        element *tmp = iterator;
        iterator = iterator->next;
        free(tmp);
    } while (iterator != *head);

    *head = NULL;
}

void list_process(element *head, int (*action)(int)) {
    if (list_empty(head)) {
        return;
    }

    element *iterator = head;

    do {
        iterator->data = action(iterator->data);
        iterator = iterator->next;
    } while (iterator != head);
}
