#ifndef CIRC_LIST_H
#define CIRC_LIST_H

#include <stdbool.h>

typedef struct element {
    int data;
    struct element *next;
} element;

element *list_create();
bool list_empty(element *head);
unsigned int list_count(element *head);
element *list_move(element *head);
element *list_insert_after(element *head, int data);
element *list_insert_before(element *head, int data);
element *list_search(element *head, int data);
element *list_remove(element **head, int data);
void list_free(element **head);
void list_process(element *head, int (*action)(int));

#endif
