#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

#include "circ_list.h"

element *add_number_to_circular_list(element *list, int number) {
    return list_insert_after(list, number);
}

element *remove_kth_element(element *head, int k) {
    for (int32_t i = 0; i < k; i += 1) {
        head = list_move(head);
    }

    element *removed_element = list_remove(&head, head->data);
    printf("%d\n", removed_element->data);
    free(removed_element);

    return head;
}

int main(int argc, char *argv[]) {
    if (argc != 3) {
        return EXIT_FAILURE;
    }

    int32_t n = atoi(argv[1]);
    int32_t k = atoi(argv[2]);

    element *head = list_create();

    for (int32_t i = 1; i <= n; i += 1) {
        head = add_number_to_circular_list(head, i);
    }

    while (!list_empty(head)) {
        head = remove_kth_element(head, k);
    }

    return EXIT_SUCCESS;
}
