#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

int32_t **sort_array(int32_t *array, int32_t array_length) {
    int32_t **ptr = (int32_t **)malloc(sizeof(int32_t *) * array_length);

    for (int32_t i = 0; i < array_length; i += 1) {
        ptr[i] = &array[i];
    }

    // Sorting applied on the array of pointers.
    for (int32_t i = array_length - 1; i >= 1; i -= 1) {
        for (int32_t j = 0; j <= i - 1; j += 1) {
            if (*ptr[j + 1] < *ptr[j]) {
                int32_t *tmp = ptr[j];
                ptr[j] = ptr[j + 1];
                ptr[j + 1] = tmp;
            }
        }
    }

    return ptr;
}

int main(int argc, char *argv[]) {
    int32_t array_length = argc - 1;
    int32_t *array = (int32_t *)malloc(sizeof(int32_t) * array_length);

    for (int32_t i = 0; i < array_length; i += 1) {
        array[i] = atoi(argv[i + 1]);
    }

    int32_t **ptr = sort_array(array, array_length);

    for (int32_t i = 0; i < array_length; i += 1) {
        printf("%d\n", *ptr[i]);
    }

    free(ptr);
    free(array);

    return EXIT_SUCCESS;
}
